#include <bits/stdc++.h>

using namespace std;

int test;
string mode;
int minN, maxN;
int minQ, maxQ;
int P;

long long randNumber(long long l, long long r) {
	long long x = ((rand() << 16LL) + rand()) % 1000000000;
	long long y = ((rand() << 16LL) + rand()) % 1000000000;
	long long z = ((rand() << 16LL) + rand()) % 1000000000;
	long long res = (x * y + z) % (r - l + 1) + l;
	return res;
}

bool getParams(int argc, char *argv[]) {
	if (argc == 1)
		return false;
	test = atol(argv[1]);
	mode = string(argv[2]);
	minN = atol(argv[3]);
	maxN = atol(argv[4]);
	minQ = atol(argv[5]);
	maxQ = atol(argv[6]);
	if (mode == "rand") {
		P = atol(argv[7]);
	}
	return true;
}

void readParams() {
	cin >> test;
	cin >> mode;
	cin >> minN >> maxN;
	cin >> minQ >> maxQ;
	if (mode == "rand") {
		cin >> P;
	}
}

void writeTest(int n, vector<int> v) {
	cout << n << " " << v.size() << endl;
	for (auto x : v) {
		cout << x + 1 << " ";
	}
	cout << endl;
}

vector<int> genFixed(int n, int q) {
	vector<int> v[2];
	if (n <= 1e6) {
		for (int j = 0; j < 2; ++j) {
			for (int i = j; i < n; i += 2) {
				v[j].push_back(i);
			}
			random_shuffle(v[j].begin(), v[j].end());
		}
	} else {
		set<int> s;
		for (int j = 0; j < 2; ++j) {
			while (v[j].size() < q) {
				int x = randNumber(0, n - 1);
				if (x % 2 != j) {
					x += (x > 1 ? -1 : 1);
				}
				if (s.find(x) != s.end())
					continue;
				s.insert(x);
				v[j].push_back(x);
			}
		}
	}

	if (rand() & 1) {
		swap(v[0], v[1]);
	}

	vector<int> test;
	if (v[0].size() + v[1].size() <= q) {
		test = v[0];
	} else {
		for (int i = 0; i < q / 2; ++i) {
			test.push_back(v[0][i]);
		}
	}
	for (int i = 0; test.size() != q; ++i) {
		test.push_back(v[1][i]);
	}
	return test;
}

vector<int> genRand(int n, int q) {
	vector<int> v;
	if (n <= 1e6) {
		for (int i = 0; i < n; ++i) {
			v.push_back(i);
		}
		random_shuffle(v.begin(), v.end());
	} else {
		set<int> s;
		while (v.size() < q) {
			int x = randNumber(0, n - 1);
			if (s.find(x) != s.end())
				continue;
			s.insert(x);
			v.push_back(x);
		}
	}

	priority_queue<pair<int, int>> p;
	map<int, bool> u;
	vector<int> test;

	auto push = [&](int i) {
		if (u[i])
			return;
		u[i] = true;
		test.push_back(i);
		p.push({randNumber(1, 1e9), (i - 1 + n) % n});
		p.push({randNumber(1, 1e9), (i + 1) % n});
	};

	int idx = 0;
	while (test.size() != q) {
		if (p.size() && randNumber(0, 100) <= P) {
			push(p.top().second);
			p.pop();
		} else {
			push(v[idx]);
			idx ++;
		}
	}
	return test;
}

int main(int argc, char *argv[]) {
	if (!getParams(argc, argv))
		readParams();

	srand(test + minN + maxN + minQ + maxQ + P);

	int n = randNumber(minN, maxN);
	minQ = min(minQ, n);
	maxQ = min(maxQ, n);
	int q = randNumber(minQ, maxQ);

	if (mode == "fixed") {
		writeTest(n, genFixed(n, q));
	} else {
		writeTest(n, genRand(n, q));
	}
	return 0;
}
